﻿from html.parser import HTMLParser

class ISO3166_1JPHTMLParser(HTMLParser):
    def __init__(self):
      HTMLParser.__init__(self)
      self.data = {}
      self.tdcount = -1
      self.isjpname = False
      self.isengname = False
      self.iscode = False
    def handle_starttag(self, tag, attrs):
        attrs = dict(attrs)
        if tag == "tr":
          self.tdcount = -1
        elif tag == "td":
          self.isjpname = False
          self.isengname = False
          self.iscode = False
          self.isnamecount = 0;
          self.tdcount += 1
          if self.tdcount == 1:
            self.isengname = True
          elif self.tdcount == 3:
            self.iscode = True
        elif tag == "a":
          if self.tdcount == 0:
            self.isjpname = True
    def handle_endtag(self, tag):
         pass
    def handle_data(self, data):
        if self.iscode:
          self.data[data] = {
            'jpname': self.jpname,
            'engname': self.engname,
          }
          self.iscode = False
        elif self.isjpname:
          self.jpname = data
          self.isjpname = False
        elif self.isengname:
          self.engname = data
          self.isengname = False

iso3166_1parser = ISO3166_1JPHTMLParser()
with open("iso3166-1jp.html", encoding="utf-8") as f:
  s = f.read()
  iso3166_1parser.feed(s)

with open("iso3166.txt", mode='w', encoding="utf-8") as f:
  f.write(' CHOICES = (\n')
  for k, v in sorted(iso3166_1parser.data.items()):
    f.write("  ('" + k + "', _('iso3166_1_a3_" + k + "'),\n")
  f.write(' )\n')

#  for k, v in sorted(iso3166_1parser.data.items()):
#    f.write(" '" + k + "': {\n")
#    f.write("    'jpname': '" + iso3166_1parser.data[k]["jpname"] + "',\n")
#    f.write("    'engname': '" + iso3166_1parser.data[k]["engname"] + "',\n")
#    f.write(' },\n')
#  f.write('}\n')

